/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2020 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "usb_device.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "usbd_cdc_if.h"
#include "stm32f1xx.h"

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
#define LED_PORT	GPIOC
#define LED_PIN		GPIO_PIN_13

#define SW_PORT		GPIOA
#define SW_PIN		GPIO_PIN_0

#define IOC_PORT	GPIOC
#define IOC_PINS	GPIO_PIN_13

#define IOA_PORT	GPIOA
#define IOA_PINS	(GPIO_PIN_1 | GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 \
					| GPIO_PIN_5 | GPIO_PIN_6 | GPIO_PIN_7 | GPIO_PIN_8 | GPIO_PIN_9 \
					| GPIO_PIN_10 | GPIO_PIN_15)

#define IOB_PORT	GPIOB
#define IOB_PINS	(GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5 \
					| GPIO_PIN_6 | GPIO_PIN_7 | GPIO_PIN_8 | GPIO_PIN_9 | GPIO_PIN_10\
					| GPIO_PIN_11 | GPIO_PIN_12 | GPIO_PIN_13 | GPIO_PIN_14 | GPIO_PIN_15)

#define TEST1_APINS	(GPIO_PIN_1 | /*GPIO_PIN_2 |*/ GPIO_PIN_3 /*| GPIO_PIN_4*/ \
					| GPIO_PIN_5 | /*GPIO_PIN_6 |*/ GPIO_PIN_7 | GPIO_PIN_8 /*| GPIO_PIN_9*/ \
					| GPIO_PIN_10 | GPIO_PIN_15)

#define TEST1_BPINS	(/*GPIO_PIN_0 |*/ GPIO_PIN_1 | /*GPIO_PIN_3 |*/ GPIO_PIN_4 | /*GPIO_PIN_5 \
					|*/ GPIO_PIN_6 | /*GPIO_PIN_7 |*/ GPIO_PIN_8 /*| GPIO_PIN_9 |*/ /*GPIO_PIN_10*/\
					| GPIO_PIN_11 | GPIO_PIN_12 | /*GPIO_PIN_13 |*/ GPIO_PIN_14 /*| GPIO_PIN_15*/)

//#define TEST1_CPINS (GPIO_PIN_13)

#define TEST2_APINS	(/*GPIO_PIN_1 |*/GPIO_PIN_2 | /*GPIO_PIN_3 |*/GPIO_PIN_4 \
					| /*GPIO_PIN_5 |*/GPIO_PIN_6 | /*GPIO_PIN_7 | GPIO_PIN_8 |*/GPIO_PIN_9 \
					/*| GPIO_PIN_10 | GPIO_PIN_15*/)

#define TEST2_BPINS	(GPIO_PIN_0 | /*GPIO_PIN_1 |*/GPIO_PIN_3 | /*GPIO_PIN_4 |*/ GPIO_PIN_5 | \
					 /*GPIO_PIN_6 |*/ GPIO_PIN_7 | /*GPIO_PIN_8 |*/ GPIO_PIN_9 | GPIO_PIN_10 \
					| /*GPIO_PIN_11 | GPIO_PIN_12 |*/ GPIO_PIN_13 | /*GPIO_PIN_14 |*/ GPIO_PIN_15)

//#define TEST2_CPINS (0/*GPIO_PIN_13*/)

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
RTC_HandleTypeDef hrtc;

/* USER CODE BEGIN PV */
RTC_HandleTypeDef hrtc;
extern USBD_HandleTypeDef hUsbDeviceFS;
char message[64];
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_RTC_Init(void);
/* USER CODE BEGIN PFP */
void IO_Configure(int state);
void MessageManager(RTC_TimeTypeDef *t);
/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

// this is called from usbd_cdc_if.c when data arrives so echo it back to cdc device
void echo_received_data(uint8_t *data, uint32_t length)
{
  CDC_Transmit_FS(data, length);
}

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{

  /* USER CODE BEGIN 1 */
	int message_period = 0;
	int config_state = 0;
	int ports_state = 0;
	RTC_TimeTypeDef time = {0};

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_USB_DEVICE_Init();
  MX_RTC_Init();
  /* USER CODE BEGIN 2 */
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
	// led blinks
	//HAL_GPIO_WritePin(LED_PORT, LED_PIN, ports_state&1);

	if (HAL_GPIO_ReadPin(SW_PORT, SW_PIN) > 0){
		HAL_GPIO_WritePin(LED_PORT, LED_PIN, ports_state&4);

		if (config_state > 0){
			HAL_GPIO_WritePin(IOA_PORT, IOA_PINS, 0);
			HAL_GPIO_WritePin(IOB_PORT, IOB_PINS, 0);
			//HAL_GPIO_WritePin(IOC_PORT, IOC_PINS, 0);
			IO_Configure(0);
			config_state = 0;
		}

	} else {
		HAL_GPIO_WritePin(LED_PORT, LED_PIN, ports_state&1);
		if (config_state == 0){
			IO_Configure(1);
			config_state = 1;
		}

		if (config_state == 1){
			if (ports_state&1){
				HAL_GPIO_WritePin(IOA_PORT, TEST2_APINS, 0);
				HAL_GPIO_WritePin(IOB_PORT, TEST2_BPINS, 0);
				//HAL_GPIO_WritePin(IOC_PORT, TEST2_CPINS, 0);

				HAL_GPIO_WritePin(IOA_PORT, TEST1_APINS, 1);
				HAL_GPIO_WritePin(IOB_PORT, TEST1_BPINS, 1);
				//HAL_GPIO_WritePin(IOC_PORT, TEST1_CPINS, 1);
			} else {
				HAL_GPIO_WritePin(IOA_PORT, TEST1_APINS, 0);
				HAL_GPIO_WritePin(IOB_PORT, TEST1_BPINS, 0);
				//HAL_GPIO_WritePin(IOC_PORT, TEST1_CPINS, 0);

				HAL_GPIO_WritePin(IOA_PORT, TEST2_APINS, 1);
				HAL_GPIO_WritePin(IOB_PORT, TEST2_BPINS, 1);
				//HAL_GPIO_WritePin(IOC_PORT, TEST2_CPINS, 1);
			}
			//HAL_GPIO_WritePin(IOA_PORT, IOA_PINS, ports_state&1);
			//HAL_GPIO_WritePin(IOB_PORT, IOB_PINS, ports_state&2);
		}
	}

	// check if plugged into a host
	if (message_period >= 11){
		message_period = 0;
		if (hUsbDeviceFS.dev_state == USBD_STATE_CONFIGURED)
		{
		  HAL_RTC_GetTime(&hrtc, &time, RTC_FORMAT_BIN);
		  //time.Seconds++;
		  MessageManager(&time);
		  // plugged in & connected, so send this message periodically
		  CDC_Transmit_FS((uint8_t *)message, 30);
		}
	}

	HAL_Delay(200U);
	message_period++;
	ports_state++;
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};
  RCC_PeriphCLKInitTypeDef PeriphClkInit = {0};

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_LSI|RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.LSIState = RCC_LSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
  PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_RTC|RCC_PERIPHCLK_USB;
  PeriphClkInit.RTCClockSelection = RCC_RTCCLKSOURCE_LSI;
  PeriphClkInit.UsbClockSelection = RCC_USBCLKSOURCE_PLL_DIV1_5;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief RTC Initialization Function
  * @param None
  * @retval None
  */
static void MX_RTC_Init(void)
{

  /* USER CODE BEGIN RTC_Init 0 */

  /* USER CODE END RTC_Init 0 */

  RTC_TimeTypeDef sTime = {0};
  RTC_DateTypeDef DateToUpdate = {0};

  /* USER CODE BEGIN RTC_Init 1 */

  /* USER CODE END RTC_Init 1 */

  /** Initialize RTC Only
  */
  hrtc.Instance = RTC;
  hrtc.Init.AsynchPrediv = RTC_AUTO_1_SECOND;
  hrtc.Init.OutPut = RTC_OUTPUTSOURCE_NONE;
  if (HAL_RTC_Init(&hrtc) != HAL_OK)
  {
    Error_Handler();
  }

  /* USER CODE BEGIN Check_RTC_BKUP */

  /* USER CODE END Check_RTC_BKUP */

  /** Initialize RTC and set the Time and Date
  */
  sTime.Hours = 0x0;
  sTime.Minutes = 0x0;
  sTime.Seconds = 0x0;

  if (HAL_RTC_SetTime(&hrtc, &sTime, RTC_FORMAT_BCD) != HAL_OK)
  {
    Error_Handler();
  }
  DateToUpdate.WeekDay = RTC_WEEKDAY_MONDAY;
  DateToUpdate.Month = RTC_MONTH_JANUARY;
  DateToUpdate.Date = 0x1;
  DateToUpdate.Year = 0x0;

  if (HAL_RTC_SetDate(&hrtc, &DateToUpdate, RTC_FORMAT_BCD) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN RTC_Init 2 */

  /* USER CODE END RTC_Init 2 */

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
/* USER CODE BEGIN MX_GPIO_Init_1 */
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();
  __HAL_RCC_GPIOC_CLK_ENABLE();
/* USER CODE END MX_GPIO_Init_1 */

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOD_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();

/* USER CODE BEGIN MX_GPIO_Init_2 */
	GPIO_InitTypeDef GPIO_InitPinStruct = {0};

	GPIO_InitPinStruct.Pin = LED_PIN;
	GPIO_InitPinStruct.Mode = GPIO_MODE_OUTPUT_PP;
	GPIO_InitPinStruct.Pull = GPIO_NOPULL;
	GPIO_InitPinStruct.Speed = GPIO_SPEED_FREQ_LOW;
	HAL_GPIO_Init(LED_PORT, &GPIO_InitPinStruct);

	GPIO_InitPinStruct.Pin = SW_PIN;
	GPIO_InitPinStruct.Mode = GPIO_MODE_INPUT;
	GPIO_InitPinStruct.Pull = GPIO_PULLUP;
	GPIO_InitPinStruct.Speed = GPIO_SPEED_FREQ_LOW;
	HAL_GPIO_Init(SW_PORT, &GPIO_InitPinStruct);
/* USER CODE END MX_GPIO_Init_2 */
}

/* USER CODE BEGIN 4 */
void IO_Configure(int state){
	GPIO_InitTypeDef GPIO_InitPinStruct = {0};
	if (state > 0){
		GPIO_InitPinStruct.Pin = IOA_PINS;
		GPIO_InitPinStruct.Mode = GPIO_MODE_OUTPUT_PP;
		GPIO_InitPinStruct.Pull = GPIO_NOPULL;
		GPIO_InitPinStruct.Speed = GPIO_SPEED_FREQ_LOW;
		HAL_GPIO_Init(IOA_PORT, &GPIO_InitPinStruct);

		GPIO_InitPinStruct.Pin = IOB_PINS;
		GPIO_InitPinStruct.Mode = GPIO_MODE_OUTPUT_PP;
		GPIO_InitPinStruct.Pull = GPIO_NOPULL;
		GPIO_InitPinStruct.Speed = GPIO_SPEED_FREQ_LOW;
		HAL_GPIO_Init(IOB_PORT, &GPIO_InitPinStruct);

		//GPIO_InitPinStruct.Pin = IOC_PINS;
		//GPIO_InitPinStruct.Mode = GPIO_MODE_OUTPUT_PP;
		//GPIO_InitPinStruct.Pull = GPIO_NOPULL;
		//GPIO_InitPinStruct.Speed = GPIO_SPEED_FREQ_LOW;
		//HAL_GPIO_Init(IOC_PORT, &GPIO_InitPinStruct);
	} else {
		GPIO_InitPinStruct.Pin = IOA_PINS;
		GPIO_InitPinStruct.Mode = GPIO_MODE_INPUT;
		GPIO_InitPinStruct.Pull = GPIO_NOPULL;
		GPIO_InitPinStruct.Speed = GPIO_SPEED_FREQ_LOW;
		HAL_GPIO_Init(IOA_PORT, &GPIO_InitPinStruct);

		GPIO_InitPinStruct.Pin = IOB_PINS;
		GPIO_InitPinStruct.Mode = GPIO_MODE_INPUT;
		GPIO_InitPinStruct.Pull = GPIO_NOPULL;
		GPIO_InitPinStruct.Speed = GPIO_SPEED_FREQ_LOW;
		HAL_GPIO_Init(IOB_PORT, &GPIO_InitPinStruct);

		//GPIO_InitPinStruct.Pin = IOC_PINS;
		//GPIO_InitPinStruct.Mode = GPIO_MODE_INPUT;
		//GPIO_InitPinStruct.Pull = GPIO_NOPULL;
		//GPIO_InitPinStruct.Speed = GPIO_SPEED_FREQ_LOW;
		//HAL_GPIO_Init(IOC_PORT, &GPIO_InitPinStruct);
	}
}


void MessageManager(RTC_TimeTypeDef *t){
	message[0] = 'K';
	message[1] = 'A';
	message[2] = 'm';
	message[3] = 'o';
	message[4] = 'd';
	message[5] = ' ';
	message[6] = 'B';
	message[7] = 'l';
	message[8] = 'u';
	message[9] = 'e';
	message[10] = 'P';
	message[11] = 'i';
	message[12] = 'l';
	message[13] = 'l';
	message[14] = '+';
	message[15] = ' ';

	message[16] = 'R';
	message[17] = 'T';
	message[18] = 'C';
	message[19] = ':';

	message[20] = ((t->Hours/10) + '0');
	message[21] = ((t->Hours%10) + '0');
	message[22] = ':';
	message[23] = ((t->Minutes/10) + '0');
	message[24] = ((t->Minutes%10) + '0');
	message[25] = ':';
	message[26] = ((t->Seconds/10) + '0');
	message[27] = ((t->Seconds%10) + '0');

	message[28] = '\r';
	message[29] = '\n';
	message[30] = 0;
}

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
